ConnectionHTTPProxy Class Reference

`#include <connectionhttpproxy.h>`

Inheritance diagram for ConnectionHTTPProxy:
[legend]

## Public Member Functions

| ConnectionHTTPProxy (ConnectionBase *connection, const LogSink &logInstance, const std::string &server, int port=-1)
| ConnectionHTTPProxy (ConnectionDataHandler *cdh, ConnectionBase *connection, const LogSink &logInstance, const std::string &server, int port=-1)
virtual | ~ConnectionHTTPProxy ()
virtual ConnectionError | connect ()
virtual ConnectionError | recv (int timeout=-1)
virtual bool | send (const std::string &data)
virtual ConnectionError | receive ()
virtual void | disconnect ()
virtual void | cleanup ()
virtual void | getStatistics (long int &totalIn, long int &totalOut)
virtual void | handleReceivedData (const ConnectionBase *connection, const std::string &data)
virtual void | handleConnect (const ConnectionBase *connection)
virtual void | handleDisconnect (const ConnectionBase *connection, ConnectionError reason)
virtual ConnectionBase * | newInstance () const
void | setServer (const std::string &host, int port=-1)
void | setProxyAuth (const std::string &user, const std::string &password)
void | setConnectionImpl (ConnectionBase *connection)
void | setHTTP11 (bool http11)
Public Member Functions inherited from ConnectionBase
| ConnectionBase (ConnectionDataHandler *cdh)
virtual | ~ConnectionBase ()
ConnectionState | state () const
void | registerConnectionDataHandler (ConnectionDataHandler *cdh)
void | setServer (const std::string &server, int port=-1)
const std::string & | server () const
int | port () const
virtual int | localPort () const
virtual const std::string | localInterface () const
Public Member Functions inherited from ConnectionDataHandler
virtual | ~ConnectionDataHandler ()

## Additional Inherited Members

Protected Attributes inherited from ConnectionBase
ConnectionDataHandler * | m_handler
ConnectionState | m_state
std::string | m_server
int | m_port

## Detailed Description

This is an implementation of a simple HTTP Proxying connection.

Usage:

Client* c = new Client( ... );
ConnectionTCPClient* conn0 = new ConnectionTCPClient( c->logInstance(),
proxyHost, proxyPort );
ConnectionHTTPProxy* conn1 = new ConnectionHTTPProxy( c, conn0, c->logInstance(),
xmppHost, xmppPort );
c->setConnectionImpl( conn1 );
gloox::ClientBase::logInstance
LogSink & logInstance()
Definition clientbase.h:599
gloox::ClientBase::setConnectionImpl
void setConnectionImpl(ConnectionBase *cb)
Definition clientbase.cpp:1199
gloox::Client
This class implements a basic Jabber/XMPP Client.
Definition client.h:117
gloox::ConnectionHTTPProxy::ConnectionHTTPProxy
ConnectionHTTPProxy(ConnectionBase *connection, const LogSink &logInstance, const std::string &server, int port=-1)
Definition connectionhttpproxy.cpp:29
gloox::ConnectionTCPClient
This is an implementation of a simple TCP connection.
Definition connectiontcpclient.h:37

Make sure to pass the proxy host/port to the transport connection (ConnectionTCPClient in this case), and the XMPP host/port to the proxy connection.

ConnectionHTTPProxy uses the CONNECT method to pass through the proxy. If your proxy does not allow this kind of connections, or if it kills connections after some time, you may want to use ConnectionBOSH instead or in addition.

The reason why ConnectionHTTPProxy doesn't manage its own ConnectionTCPClient is that it allows it to be used with other transports (like IPv6 or chained SOCKS5/HTTP proxies).

Author
  Jakob Schröter js@ca.nosp@m.maya.nosp@m..net

Since
  0.9

Definition at line 53 of file connectionhttpproxy.h.

## Constructor & Destructor Documentation

## ConnectionHTTPProxy() [1/2]

ConnectionHTTPProxy | ( | ConnectionBase * | connection,
|  | const LogSink & | logInstance,
|  | const std::string & | server,
|  | int | port = -1 )

Constructs a new ConnectionHTTPProxy object.

Parameters

  connection | A transport connection. It should be configured to connect to the proxy host and port, not to the XMPP host. ConnectionHTTPProxy will own the transport connection and delete it in its destructor.
  logInstance | The log target. Obtain it from ClientBase::logInstance().
  server | A server to connect to. This is the XMPP server's address, not the proxy.
  port | The port to connect to. This is the XMPP server's port, not the proxy's. The default of -1 means that SRV records will be used to find out about the actual host:port.

Note
  To properly use this object, you have to set a ConnectionDataHandler using registerConnectionDataHandler(). This is not necessary if this object is part of a 'connection chain', e.g. with ConnectionSOCKS5Proxy.

Definition at line 29 of file connectionhttpproxy.cpp.

## ConnectionHTTPProxy() [2/2]

ConnectionHTTPProxy | ( | ConnectionDataHandler * | cdh,
|  | ConnectionBase * | connection,
|  | const LogSink & | logInstance,
|  | const std::string & | server,
|  | int | port = -1 )

Constructs a new ConnectionHTTPProxy object.

Parameters

  cdh | An ConnectionDataHandler-derived object that will handle incoming data.
  connection | A transport connection. It should be configured to connect to the proxy host and port, not to the XMPP host. ConnectionHTTPProxy will own the transport connection and delete it in its destructor.
  logInstance | The log target. Obtain it from ClientBase::logInstance().
  server | A server to connect to. This is the XMPP server's address, not the proxy.
  port | The port to connect to. This is the XMPP server's port, not the proxy's. The default of -1 means that SRV records will be used to find out about the actual host:port.

Definition at line 43 of file connectionhttpproxy.cpp.

## ~ConnectionHTTPProxy()

~ConnectionHTTPProxy | ( |  | ) |

virtual

Virtual destructor

Definition at line 58 of file connectionhttpproxy.cpp.

## Member Function Documentation

## cleanup()

void cleanup | ( |  | ) |

virtual

This function is called after a disconnect to clean up internal state. It is also called by ConnectionBase's destructor.

Reimplemented from ConnectionBase.

Definition at line 110 of file connectionhttpproxy.cpp.

## connect()

ConnectionError connect | ( |  | ) |

virtual

Used to initiate the connection.

Returns
  Returns the connection state.

Implements ConnectionBase.

Definition at line 77 of file connectionhttpproxy.cpp.

## disconnect()

void disconnect | ( |  | ) |

virtual

Disconnects an established connection. NOOP if no active connection exists.

Implements ConnectionBase.

Definition at line 88 of file connectionhttpproxy.cpp.

## getStatistics()

void getStatistics | ( | long int & | totalIn,
|  | long int & | totalOut )

virtual

Returns current connection statistics.

Parameters

  totalIn | The total number of bytes received.
  totalOut | The total number of bytes sent.

Implements ConnectionBase.

Definition at line 118 of file connectionhttpproxy.cpp.

## handleConnect()

void handleConnect | ( | const ConnectionBase * | connection | ) |

virtual

This function is called when e.g. the raw TCP connection was established.

Parameters

  connection | The connection.

Implements ConnectionDataHandler.

Definition at line 161 of file connectionhttpproxy.cpp.

## handleDisconnect()

void handleDisconnect | ( | const ConnectionBase * | connection,
|  | ConnectionError | reason )

virtual

This connection is called when e.g. the raw TCP connection was closed.

Parameters

  connection | The connection.
  reason | The reason for the disconnect.

Implements ConnectionDataHandler.

Definition at line 205 of file connectionhttpproxy.cpp.

## handleReceivedData()

void handleReceivedData | ( | const ConnectionBase * | connection,
|  | const std::string & | data )

virtual

This function is called for received from the underlying transport.

Parameters

  connection | The connection that received the data.
  data | The data received.

Implements ConnectionDataHandler.

Definition at line 126 of file connectionhttpproxy.cpp.

## newInstance()

ConnectionBase * newInstance | ( |  | ) | const

virtual

This function returns a new instance of the current ConnectionBase-derived object. The idea is to be able to 'clone' ConnectionBase-derived objects without knowing of what type they are exactly.

Returns
  A new Connection* instance.

Implements ConnectionBase.

Definition at line 63 of file connectionhttpproxy.cpp.

## receive()

ConnectionError receive | ( |  | ) |

virtual

Use this function to put the connection into 'receive mode', i.e. this function returns only when the connection is terminated.

Returns
  Returns a value indicating the disconnection reason.

Implements ConnectionBase.

Definition at line 100 of file connectionhttpproxy.cpp.

## recv()

ConnectionError recv | ( | int | timeout = -1 | ) |

virtual

Use this periodically to receive data from the socket.

Parameters

  timeout | The timeout to use for select in microseconds. Default of -1 means blocking.

Returns
  The state of the connection.

Implements ConnectionBase.

Definition at line 95 of file connectionhttpproxy.cpp.

## send()

bool send | ( | const std::string & | data | ) |

virtual

Use this function to send a string of data over the wire. The function returns only after all data has been sent.

Parameters

  data | The data to send.

Returns
  True if the data has been sent (no guarantee of receipt), false in case of an error.

Implements ConnectionBase.

Definition at line 105 of file connectionhttpproxy.cpp.

## setConnectionImpl()

void setConnectionImpl | ( | ConnectionBase * | connection | ) |

Sets the underlying transport connection. A possibly existing connection will be deleted.

Parameters

  connection | The ConnectionBase to replace the current connection, if any.

Definition at line 69 of file connectionhttpproxy.cpp.

## setHTTP11()

void setHTTP11 | ( | bool | http11 | ) |

inline

Switches usage of HTTP/1.1 on or off.

Parameters

  http11 | Set this to true to connect through a HTTP/1.1-only proxy, or false to use HTTP/1.0. Defaults to HTTP/1.0 which should work with 99.9% of proxies.

Definition at line 153 of file connectionhttpproxy.h.

## setProxyAuth()

void setProxyAuth | ( | const std::string & | user,
|  | const std::string & | password )

inline

Sets proxy authorization credentials.

Parameters

  user | The user name to use for proxy authorization.
  password | The password to use for proxy authorization.

Definition at line 139 of file connectionhttpproxy.h.

## setServer()

void setServer | ( | const std::string & | host,
|  | int | port = -1 )

inline

Sets the XMPP server to proxy to.

Parameters

  host | The XMPP server hostname (IP address).
  port | The XMPP server port. The default of -1 means that SRV records will be used to find out about the actual host:port.

Definition at line 131 of file connectionhttpproxy.h.

The documentation for this class was generated from the following files:

- connectionhttpproxy.h
- connectionhttpproxy.cpp